/* PRO-SCAMS "@@(#) edit_funcs.c, Rev: 1.2.0.0" */


/* -----                                                                */
/*                                                                      */
/* UWDIALER Version 1.0                                        12/11/93 */
/*                                                                      */
/* AUTHOR: William C. Brown                                             */
/* VERSION: 1.0 (beta)                                                  */
/* DESCRIPTION: To provide a nice X based dialer interface that works   */
/*              in conjunction with the connection server in SVR4.2.    */
/*                                                                      */
/* -------------------------------------------------------------------- */
/* Notes:                                                               */
/*                                                                      */
/*                                                                ----- */

#include <stdio.h>
#include <pwd.h>
#include <termio.h>
#include <unistd.h>
#include <errno.h>

#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>
#include <Xol/OpenLook.h>
#include <Xol/RubberTile.h>
#include <Xol/Form.h>
#include <Xol/FButtons.h>
#include <Xol/Caption.h>
#include <Xol/TextField.h>
#include <Xol/StaticText.h>
#include <Xol/ScrollingL.h>

#include "uwdialer.h"

void Modify_Systems(OlListToken Token, int Indicator)
{
	char Buffer[BUFSIZ];
	char System_Name[BUFSIZ];
	char Temp[BUFSIZ];
	Boolean Found = False;
	struct sys *ptr;
	FILE *fp, *target, *fopen();
	extern char Systems_File[];
	extern struct sys *systems;
	extern OlListToken LastToken;

	for(ptr=systems;ptr!=NULL;ptr=ptr->next) {
		if(ptr->token == Token) {
			Found = True;
			break;
		}
	}

	if(Found == False) {
		(void)DialerError(NONFATAL, BADSYSTEMSLIST);
		return;
	}

	if((fp = fopen(Systems_File, READ)) == NULL) { 
		(void)DialerError(NONFATAL, PERSONALFILE, Systems_File);
		return;
	}

	if((target = fopen(TARGET_FILE, WRITE)) == NULL) { 
		(void)DialerError(NONFATAL, TARGETFILE);
		(void)fclose(fp);
		return;
	}

	while((fgets(Buffer, BUFSIZ, fp)) != NULL) {
		(void)strcpy(Temp, Buffer);
		(void)strcpy(System_Name, strtok(Buffer, ";"));
		if(strncmp(System_Name, ptr->System, strlen(System_Name))==0) {
			if(Indicator == DELETE)
				continue;
			else if (Indicator == MODIFY) {
				(void)Insert_Modified_System(target);
				continue;
			}
		}
		if(fputs(Temp, target) == EOF) {
			(void)DialerError(NONFATAL, WRITETARGET);
			(void)fclose(fp);
			(void)fclose(target);
			return;
		}
	} /* while */

	(void)fclose(fp);
	(void)fclose(target);

	if((fp = fopen(Systems_File, WRITE)) == NULL) { 
		(void)DialerError(NONFATAL, PERSONALFILE, Systems_File);
		return;
	}

	if((target = fopen(TARGET_FILE, READ)) == NULL) { 
		(void)DialerError(NONFATAL, TARGETFILE);
		(void)fclose(fp);
		return;
	}

	while((fgets(Buffer, BUFSIZ, target)) != NULL) {
		if(fputs(Buffer, fp) == EOF) {
		     (void)DialerError(NONFATAL, WRITEPERSONAL, Systems_File);
		     break;
		}
	} /* while */

	(void)fclose(fp);
	(void)fclose(target);
	(void)unlink(TARGET_FILE);

	LastToken = NULL;

} /* Modify_Systems */

void Edit_System_List(OlListToken Token)
{
	Boolean Found = False;
	char Buffer[BUFSIZ];
	char System_Name[BUFSIZ];
	char Temp[BUFSIZ];
	FILE *fp, *fopen();
	struct sys *ptr;
	extern Dial_Info DialInfoBuf;
	extern struct sys *systems;
	extern char Systems_File[];

	for(ptr=systems;ptr!=NULL;ptr=ptr->next) {
                if(ptr->token == Token) {
                        Found = True;
                        break;
                }
        }

        if(Found == False) {
                (void)DialerError(NONFATAL, BADSYSTEMSLIST);
                return;
        }

        if((fp = fopen(Systems_File, READ)) == NULL) {
                (void)DialerError(NONFATAL, PERSONALFILE, Systems_File);
                return;
        }

	while((fgets(Buffer, BUFSIZ, fp)) != NULL) {
                (void)strcpy(Temp, Buffer);
                (void)strcpy(System_Name, strtok(Buffer, ";"));
                if(strncmp(System_Name, ptr->System, strlen(System_Name)) == 0)
			break;
        } /* while */

	Temp[strlen(Temp)-1] = NULL;

	(void)fclose(fp);

	(void)Settings(MODIFY);
	(void)Set_Settings_Screen(Temp);
} /* Edit_System_List */

void Insert_Modified_System(FILE *fp)
{
	extern Dial_Info DialInfoBuf;

	(void)fprintf(fp, "%s;", DialInfoBuf.System);
        (void)fprintf(fp, "%s;", DialInfoBuf.Line);
        (void)fprintf(fp, "%d;", DialInfoBuf.Speed);
        switch (DialInfoBuf.CharSize) {
                case CS8:
                        (void)fprintf(fp, "%s;", "CS8");
                        break;
                case CS7:
                        (void)fprintf(fp, "%s;", "CS7");
                        break;
                case CS6:
                        (void)fprintf(fp, "%s;", "CS6");
                        break;
                default:
                        (void)fprintf(fp, "%s;", "CS8");
        }
        switch(DialInfoBuf.Parity) {
                case (PARENB|PARODD):
                        (void)fprintf(fp, "%s;", "ODD");
                        break;
                case (PARENB):
                        (void)fprintf(fp, "%s;", "EVEN");
                        break;
                default:
                        (void)fprintf(fp, "%s;", "NONE");
        }

        switch(DialInfoBuf.Flow) {
                case (IXON|IXOFF):
                        (void)fprintf(fp, "%s\n", "ON");
                        break;
                default:
                        (void)fprintf(fp, "%s\n", "OFF");
        }
} /* Insert_Modified_System */

